local prefix = "|cFFFF0000MimironFFA:|r "
local lootmethod, masterlooter
local L = {}

-- if your locale is missing, add the appropriate phase 3 and phase 4 yells at
-- http://www.wowace.com/projects/mimironffa/localization/
-- and either write a comment, open a ticket or drop me a line at gnarfoz@gmail.com


if GetLocale() == "enUS" then
L["not_leader"] = "You are not the raid leader! Cannot change loot method."
L["phase3"] = "^Thank you, friends!"
L["phase4"] = "^Preliminary testing phase complete"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "deDE" then
L["not_leader"] = "Du bist nicht Schlachtzugsleiter! Kann die Plündermethode nicht umstellen!"
L["phase3"] = "^Danke Euch, Freunde!"
L["phase4"] = "^Vorversuchsphase abgeschlossen"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "frFR" then
L["not_leader"] = "You are not the raid leader! Cannot change loot method." -- Requires localization
L["phase3"] = "^Merci, les amis !"
L["phase4"] = "^Fin de la phase d'essais préliminaires"
L["Ulduar"] = "Ulduar"

elseif GetLocale() == "koKR" then
L["not_leader"] = "당신은 공격대 지휘관이 아닙니다! 전리품 획득 방식을 변경할 수 없습니다."
L["phase3"] = "^고맙다, 친구들!"
L["phase4"] = "^예비 시험은 이걸로 끝이다"
L["Ulduar"] = "울두아르"

elseif GetLocale() == "zhTW" then
L["not_leader"] = "你不是團長! 無法更改拾取方式!"
L["phase3"] = "^感謝你"
L["phase4"] = "^初步測試階段完成"
L["Ulduar"] = "奧杜亞"

elseif GetLocale() == "ruRU" then
L["not_leader"] = "Вы не являетесь лидером рейда! Невозможно изменить способ распределения добычи."
L["phase3"] = "^Спасибо, друзья!"
L["phase4"] = "^Фаза предварительной проверки завершена"
L["Ulduar"] = "Ульдуар"

else
	print(prefix.."This addon has yet to be translated for your locale. Please check the source code to help. Exiting.")
	return
end

local function SwitchToFFA() --switches to FFA loot for phase 3
	if IsRaidLeader() then
		local _, unitid
		lootmethod, _, unitid = GetLootMethod()
		if lootmethod == "master" then
			masterlooter = UnitName("raid"..unitid)
		end
		if lootmethod ~= "freeforall" then
			SetLootMethod("freeforall")
		end
	else
		print(prefix..L["not_leader"])
	end
end

local function SwitchBack() --switches back to whatever loot method was used previously
	if IsRaidLeader() then
		if lootmethod ~= GetLootMethod() then
			if lootmethod == "master" and masterlooter then
				SetLootMethod(lootmethod, masterlooter)
			else
				SetLootMethod(lootmethod)
			end
		else
			return
		end
	else
		print(prefix..L["not_leader"])
	end
end

local function OnEvent(self, event, arg1)
	if event == "CHAT_MSG_MONSTER_YELL" then
		if arg1:find(L["phase3"]) then
			SwitchToFFA()
		elseif arg1:find(L["phase4"]) then
			SwitchBack()
		end
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		if GetRealZoneText() == L["Ulduar"] then
			self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
		else
			if self:IsEventRegistered("CHAT_MSG_MONSTER_YELL") then
				self:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
			end
		end
	end
end

--Create frame for events, set OnEvent and register for Z_C_N_A for activation/deactivation purposes
local MimironFFA = CreateFrame("Frame")
MimironFFA:SetScript("OnEvent", OnEvent)
MimironFFA:RegisterEvent("ZONE_CHANGED_NEW_AREA")